' Uses DOS to print a string.

SUB StdOut(BYVAL Text AS STRING) PUBLIC

  REG 4, STRPTR(Text)   ' offset of string in DX
  REG 8, STRSEG(Text)   ' segment of string in DS
  REG 3, LEN(Text)      ' length of string in CX
  REG 2, 1              ' STDOUT file handle in BX
  REG 1, &H4000         ' service 40h in AH
  CALL INTERRUPT &H21   ' call interrupt 21h to display the string

END SUB


' Returns -1 if program is being redirected.

FUNCTION Redirection() PUBLIC AS INTEGER

  REG 1, &H4400         ' service 44h in AH
  REG 2, 1              ' STDOUT file handle in BX
  CALL INTERRUPT &H21   ' call interrupt 21h
  IF (REG(4) AND 16) = 0 THEN       ' redirection is active
    Redirection% = -1               ' so return true (-1)
  END IF

END FUNCTION
